---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_vrf Data Source - terraform-provider-iosxe"
subcategory: "VRF"
description: |-
  This data source can read the VRF configuration.
---

# iosxe_vrf (Data Source)

This data source can read the VRF configuration.

## Example Usage

```terraform
data "iosxe_vrf" "example" {
  name = "VRF1"
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `name` (String) WORD;;VRF name

### Optional

- `device` (String) A device name from the provider configuration.

### Read-Only

- `address_family_ipv4` (Boolean) Address family
- `address_family_ipv6` (Boolean) Address family
- `description` (String) VRF specific description
- `id` (String) The path of the retrieved object.
- `rd` (String) Specify Route Distinguisher
- `route_target_export` (Attributes List) Export Target-VPN community (see [below for nested schema](#nestedatt--route_target_export))
- `route_target_import` (Attributes List) Import Target-VPN community (see [below for nested schema](#nestedatt--route_target_import))
- `vpn_id` (String) Configure VPN ID in rfc2685 format

<a id="nestedatt--route_target_export"></a>
### Nested Schema for `route_target_export`

Read-Only:

- `stitching` (Boolean) VXLAN route target set
- `value` (String) Value


<a id="nestedatt--route_target_import"></a>
### Nested Schema for `route_target_import`

Read-Only:

- `stitching` (Boolean) VXLAN route target set
- `value` (String) Value


