---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_bgp_address_family_ipv4_vrf Resource - terraform-provider-iosxe"
subcategory: "BGP"
description: |-
  This resource can manage the BGP Address Family IPv4 VRF configuration.
---

# iosxe_bgp_address_family_ipv4_vrf (Resource)

This resource can manage the BGP Address Family IPv4 VRF configuration.

## Example Usage

```terraform
resource "iosxe_bgp_address_family_ipv4_vrf" "example" {
  asn     = "65000"
  af_name = "unicast"
  vrfs = [
    {
      name                   = "VRF1"
      advertise_l2vpn_evpn   = true
      redistribute_connected = true
      redistribute_static    = true
    }
  ]
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `af_name` (String) - Choices: `flowspec`, `labeled-unicast`, `mdt`, `multicast`, `mvpn`, `sr-policy`, `tunnel`, `unicast`
- `asn` (String)

### Optional

- `device` (String) A device name from the provider configuration.
- `vrfs` (Attributes List) (see [below for nested schema](#nestedatt--vrfs))

### Read-Only

- `id` (String) The path of the object.

<a id="nestedatt--vrfs"></a>
### Nested Schema for `vrfs`

Optional:

- `advertise_l2vpn_evpn` (Boolean) Advertise/export prefixes to l2vpn evpn table
- `name` (String)
- `redistribute_connected` (Boolean) Connected
- `redistribute_static` (Boolean) Static routes

## Import

Import is supported using the following syntax:

```shell
terraform import iosxe_bgp_address_family_ipv4_vrf.example "Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-bgp:bgp=65000/address-family/with-vrf/ipv4=unicast"
```
