---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_bgp_address_family_l2vpn Resource - terraform-provider-iosxe"
subcategory: "BGP"
description: |-
  This resource can manage the BGP Address Family L2VPN configuration.
---

# iosxe_bgp_address_family_l2vpn (Resource)

This resource can manage the BGP Address Family L2VPN configuration.

## Example Usage

```terraform
resource "iosxe_bgp_address_family_l2vpn" "example" {
  asn     = "65000"
  af_name = "evpn"
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `af_name` (String) - Choices: `evpn`, `vpls`
- `asn` (String)

### Optional

- `device` (String) A device name from the provider configuration.

### Read-Only

- `id` (String) The path of the object.

## Import

Import is supported using the following syntax:

```shell
terraform import iosxe_bgp_address_family_l2vpn.example "Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-bgp:bgp=65000/address-family/no-vrf/l2vpn=evpn"
```
