---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_vlan Resource - terraform-provider-iosxe"
subcategory: "Switching"
description: |-
  This resource can manage the VLAN configuration.
---

# iosxe_vlan (Resource)

This resource can manage the VLAN configuration.

## Example Usage

```terraform
resource "iosxe_vlan" "example" {
  vlan_id  = 123
  name     = "Vlan123"
  shutdown = false
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `vlan_id` (Number) a single VLAN id (allowed value range 1-4094)or Comma-separated VLAN id range.e.g. 99 or 1-30 or  1-20,30,40-50
  - Range: `1`-`4094`

### Optional

- `device` (String) A device name from the provider configuration.
- `name` (String) Ascii name of the VLAN
- `private_vlan_association` (String) Configure association between private VLANs
- `private_vlan_community` (Boolean) Configure the VLAN as a community private VLAN
- `private_vlan_isolated` (Boolean) Configure the VLAN as an isolated private VLAN
- `private_vlan_primary` (Boolean) Configure the VLAN as a primary private VLAN
- `remote_span` (Boolean) Configure as Remote SPAN VLAN
- `shutdown` (Boolean) Shutdown VLAN switching

### Read-Only

- `id` (String) The path of the object.

## Import

Import is supported using the following syntax:

```shell
terraform import iosxe_vlan.example "Cisco-IOS-XE-native:native/vlan/Cisco-IOS-XE-vlan:vlan-list=123"
```
