---
# generated by https://github.com/hashicorp/terraform-plugin-docs
page_title: "iosxe_vlan_configuration Resource - terraform-provider-iosxe"
subcategory: "Switching"
description: |-
  This resource can manage the VLAN Configuration configuration.
---

# iosxe_vlan_configuration (Resource)

This resource can manage the VLAN Configuration configuration.

## Example Usage

```terraform
resource "iosxe_vlan_configuration" "example" {
  vlan_id           = "123"
  evpn_instance     = 123
  evpn_instance_vni = 10123
}
```

<!-- schema generated by tfplugindocs -->
## Schema

### Required

- `vlan_id` (String) VLAN ID List Eg. 1-10,15

### Optional

- `access_vfi` (String) Enter VFI name
- `device` (String) A device name from the provider configuration.
- `evpn_instance` (Number) - Range: `1`-`65535`
- `evpn_instance_vni` (Number) VxLAN VNI value
  - Range: `4096`-`16777215`
- `vni` (Number) VxLAN VNI value
  - Range: `4096`-`16777215`

### Read-Only

- `id` (String) The path of the object.

## Import

Import is supported using the following syntax:

```shell
terraform import iosxe_vlan_configuration.example "Cisco-IOS-XE-native:native/vlan/Cisco-IOS-XE-vlan:configuration-entry=123"
```
