// Code generated by "gen/generator.go"; DO NOT EDIT.

package provider

import (
	"context"
	"fmt"

	"github.com/hashicorp/terraform-plugin-framework/diag"
	"github.com/hashicorp/terraform-plugin-framework/tfsdk"
	"github.com/hashicorp/terraform-plugin-framework/types"
	"github.com/hashicorp/terraform-plugin-log/tflog"
)

type dataSourceEVPNType struct{}

func (t dataSourceEVPNType) GetSchema(ctx context.Context) (tfsdk.Schema, diag.Diagnostics) {
	return tfsdk.Schema{
		// This description is used by the documentation generator and the language server.
		MarkdownDescription: "This data source can read the EVPN configuration.",

		Attributes: map[string]tfsdk.Attribute{
			"device": {
				MarkdownDescription: "A device name from the provider configuration.",
				Type:                types.StringType,
				Optional:            true,
			},
			"id": {
				MarkdownDescription: "The path of the retrieved object.",
				Type:                types.StringType,
				Computed:            true,
			},
			"replication_type_ingress": {
				MarkdownDescription: "Ingress replication",
				Type:                types.BoolType,
				Computed:            true,
			},
			"replication_type_static": {
				MarkdownDescription: "Static replication",
				Type:                types.BoolType,
				Computed:            true,
			},
			"replication_type_p2mp": {
				MarkdownDescription: "p2mp replication",
				Type:                types.BoolType,
				Computed:            true,
			},
			"replication_type_mp2mp": {
				MarkdownDescription: "mp2mp replication",
				Type:                types.BoolType,
				Computed:            true,
			},
			"mac_duplication_limit": {
				MarkdownDescription: "Number of MAC moves within specified time interval",
				Type:                types.Int64Type,
				Computed:            true,
			},
			"mac_duplication_time": {
				MarkdownDescription: "MAC duplication timer",
				Type:                types.Int64Type,
				Computed:            true,
			},
			"ip_duplication_limit": {
				MarkdownDescription: "Number of IP moves within specified time interval",
				Type:                types.Int64Type,
				Computed:            true,
			},
			"ip_duplication_time": {
				MarkdownDescription: "IP duplication timer",
				Type:                types.Int64Type,
				Computed:            true,
			},
			"router_id_loopback": {
				MarkdownDescription: "Loopback interface",
				Type:                types.Int64Type,
				Computed:            true,
			},
			"default_gateway_advertise": {
				MarkdownDescription: "Advertise Default Gateway MAC/IP routes",
				Type:                types.BoolType,
				Computed:            true,
			},
			"logging_peer_state": {
				MarkdownDescription: "Peer state transition logging",
				Type:                types.BoolType,
				Computed:            true,
			},
			"route_target_auto_vni": {
				MarkdownDescription: "Set vni-based route-target",
				Type:                types.BoolType,
				Computed:            true,
			},
		},
	}, nil
}

func (t dataSourceEVPNType) NewDataSource(ctx context.Context, in tfsdk.Provider) (tfsdk.DataSource, diag.Diagnostics) {
	provider, diags := convertProviderType(in)

	return dataSourceEVPN{
		provider: provider,
	}, diags
}

type dataSourceEVPN struct {
	provider provider
}

func (d dataSourceEVPN) Read(ctx context.Context, req tfsdk.ReadDataSourceRequest, resp *tfsdk.ReadDataSourceResponse) {
	var config, state EVPN

	// Read config
	diags := req.Config.Get(ctx, &config)
	resp.Diagnostics.Append(diags...)
	if resp.Diagnostics.HasError() {
		return
	}

	tflog.Debug(ctx, fmt.Sprintf("%s: Beginning Read", config.getPath()))

	res, err := d.provider.clients[config.Device.Value].GetData(config.getPath())
	if res.StatusCode != 404 {
		if err != nil {
			resp.Diagnostics.AddError("Client Error", fmt.Sprintf("Failed to retrieve object, got error: %s", err))
			return
		}

		state.fromBody(res.Res)
	}
	state.fromPlan(config)
	state.Id.Value = config.getPath()

	tflog.Debug(ctx, fmt.Sprintf("%s: Read finished successfully", config.getPath()))

	diags = resp.State.Set(ctx, &state)
	resp.Diagnostics.Append(diags...)
}
