// Code generated by "gen/generator.go"; DO NOT EDIT.

package provider

import (
	"context"
	"fmt"

	"github.com/hashicorp/terraform-plugin-framework/diag"
	"github.com/hashicorp/terraform-plugin-framework/tfsdk"
	"github.com/hashicorp/terraform-plugin-framework/types"
	"github.com/hashicorp/terraform-plugin-log/tflog"
)

type dataSourceVLANType struct{}

func (t dataSourceVLANType) GetSchema(ctx context.Context) (tfsdk.Schema, diag.Diagnostics) {
	return tfsdk.Schema{
		// This description is used by the documentation generator and the language server.
		MarkdownDescription: "This data source can read the VLAN configuration.",

		Attributes: map[string]tfsdk.Attribute{
			"device": {
				MarkdownDescription: "A device name from the provider configuration.",
				Type:                types.StringType,
				Optional:            true,
			},
			"id": {
				MarkdownDescription: "The path of the retrieved object.",
				Type:                types.StringType,
				Computed:            true,
			},
			"vlan_id": {
				MarkdownDescription: "a single VLAN id (allowed value range 1-4094)or Comma-separated VLAN id range.e.g. 99 or 1-30 or  1-20,30,40-50",
				Type:                types.Int64Type,
				Required:            true,
			},
			"remote_span": {
				MarkdownDescription: "Configure as Remote SPAN VLAN",
				Type:                types.BoolType,
				Computed:            true,
			},
			"private_vlan_primary": {
				MarkdownDescription: "Configure the VLAN as a primary private VLAN",
				Type:                types.BoolType,
				Computed:            true,
			},
			"private_vlan_association": {
				MarkdownDescription: "Configure association between private VLANs",
				Type:                types.StringType,
				Computed:            true,
			},
			"private_vlan_community": {
				MarkdownDescription: "Configure the VLAN as a community private VLAN",
				Type:                types.BoolType,
				Computed:            true,
			},
			"private_vlan_isolated": {
				MarkdownDescription: "Configure the VLAN as an isolated private VLAN",
				Type:                types.BoolType,
				Computed:            true,
			},
			"name": {
				MarkdownDescription: "Ascii name of the VLAN",
				Type:                types.StringType,
				Computed:            true,
			},
			"shutdown": {
				MarkdownDescription: "Shutdown VLAN switching",
				Type:                types.BoolType,
				Computed:            true,
			},
		},
	}, nil
}

func (t dataSourceVLANType) NewDataSource(ctx context.Context, in tfsdk.Provider) (tfsdk.DataSource, diag.Diagnostics) {
	provider, diags := convertProviderType(in)

	return dataSourceVLAN{
		provider: provider,
	}, diags
}

type dataSourceVLAN struct {
	provider provider
}

func (d dataSourceVLAN) Read(ctx context.Context, req tfsdk.ReadDataSourceRequest, resp *tfsdk.ReadDataSourceResponse) {
	var config, state VLAN

	// Read config
	diags := req.Config.Get(ctx, &config)
	resp.Diagnostics.Append(diags...)
	if resp.Diagnostics.HasError() {
		return
	}

	tflog.Debug(ctx, fmt.Sprintf("%s: Beginning Read", config.getPath()))

	res, err := d.provider.clients[config.Device.Value].GetData(config.getPath())
	if res.StatusCode != 404 {
		if err != nil {
			resp.Diagnostics.AddError("Client Error", fmt.Sprintf("Failed to retrieve object, got error: %s", err))
			return
		}

		state.fromBody(res.Res)
	}
	state.fromPlan(config)
	state.Id.Value = config.getPath()

	tflog.Debug(ctx, fmt.Sprintf("%s: Read finished successfully", config.getPath()))

	diags = resp.State.Set(ctx, &state)
	resp.Diagnostics.Append(diags...)
}
