// Code generated by "gen/generator.go"; DO NOT EDIT.

package provider

import (
	"fmt"
	"strconv"

	"github.com/hashicorp/terraform-plugin-framework/types"
	"github.com/netascode/terraform-provider-iosxe/internal/provider/helpers"
	"github.com/tidwall/gjson"
	"github.com/tidwall/sjson"
)

type BGPAddressFamilyIPv4VRF struct {
	Device types.String                  `tfsdk:"device"`
	Id     types.String                  `tfsdk:"id"`
	Asn    types.String                  `tfsdk:"asn"`
	AfName types.String                  `tfsdk:"af_name"`
	Vrfs   []BGPAddressFamilyIPv4VRFVrfs `tfsdk:"vrfs"`
}
type BGPAddressFamilyIPv4VRFVrfs struct {
	Name                  types.String `tfsdk:"name"`
	AdvertiseL2vpnEvpn    types.Bool   `tfsdk:"advertise_l2vpn_evpn"`
	RedistributeConnected types.Bool   `tfsdk:"redistribute_connected"`
	RedistributeStatic    types.Bool   `tfsdk:"redistribute_static"`
}

func (data BGPAddressFamilyIPv4VRF) getPath() string {
	return fmt.Sprintf("Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-bgp:bgp=%v/address-family/with-vrf/ipv4=%s", data.Asn.Value, data.AfName.Value)
}

func (data BGPAddressFamilyIPv4VRF) toBody() string {
	body := `{"` + helpers.LastElement(data.getPath()) + `":{}}`
	if !data.AfName.Null && !data.AfName.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"af-name", data.AfName.Value)
	}
	if len(data.Vrfs) > 0 {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"vrf", []interface{}{})
		for index, item := range data.Vrfs {
			if !item.Name.Null && !item.Name.Unknown {
				body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"vrf"+"."+strconv.Itoa(index)+"."+"name", item.Name.Value)
			}
			if !item.AdvertiseL2vpnEvpn.Null && !item.AdvertiseL2vpnEvpn.Unknown {
				if item.AdvertiseL2vpnEvpn.Value {
					body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"vrf"+"."+strconv.Itoa(index)+"."+"ipv4-unicast.advertise.l2vpn.evpn", map[string]string{})
				}
			}
			if !item.RedistributeConnected.Null && !item.RedistributeConnected.Unknown {
				if item.RedistributeConnected.Value {
					body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"vrf"+"."+strconv.Itoa(index)+"."+"ipv4-unicast.redistribute-vrf.connected", map[string]string{})
				}
			}
			if !item.RedistributeStatic.Null && !item.RedistributeStatic.Unknown {
				if item.RedistributeStatic.Value {
					body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"vrf"+"."+strconv.Itoa(index)+"."+"ipv4-unicast.redistribute-vrf.static", map[string]string{})
				}
			}
		}
	}
	return body
}

func (data *BGPAddressFamilyIPv4VRF) fromBody(res gjson.Result) {
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "vrf"); value.Exists() {
		data.Vrfs = make([]BGPAddressFamilyIPv4VRFVrfs, 0)
		value.ForEach(func(k, v gjson.Result) bool {
			item := BGPAddressFamilyIPv4VRFVrfs{}
			if cValue := v.Get("name"); cValue.Exists() {
				item.Name.Value = cValue.String()
			}
			if cValue := v.Get("ipv4-unicast.advertise.l2vpn.evpn"); cValue.Exists() {
				item.AdvertiseL2vpnEvpn.Value = true
			}
			if cValue := v.Get("ipv4-unicast.redistribute-vrf.connected"); cValue.Exists() {
				item.RedistributeConnected.Value = true
			}
			if cValue := v.Get("ipv4-unicast.redistribute-vrf.static"); cValue.Exists() {
				item.RedistributeStatic.Value = true
			}
			data.Vrfs = append(data.Vrfs, item)
			return true
		})
	}
}

func (data *BGPAddressFamilyIPv4VRF) fromPlan(plan BGPAddressFamilyIPv4VRF) {
	data.Device = plan.Device
	data.Asn.Value = plan.Asn.Value
	data.AfName.Value = plan.AfName.Value
}
