// Code generated by "gen/generator.go"; DO NOT EDIT.

package provider

import (
	"fmt"
	"strconv"

	"github.com/hashicorp/terraform-plugin-framework/types"
	"github.com/netascode/terraform-provider-iosxe/internal/provider/helpers"
	"github.com/tidwall/gjson"
	"github.com/tidwall/sjson"
)

type OSPFVRF struct {
	Device                            types.String            `tfsdk:"device"`
	Id                                types.String            `tfsdk:"id"`
	ProcessId                         types.Int64             `tfsdk:"process_id"`
	Vrf                               types.String            `tfsdk:"vrf"`
	BfdAllInterfaces                  types.Bool              `tfsdk:"bfd_all_interfaces"`
	DefaultInformationOriginate       types.Bool              `tfsdk:"default_information_originate"`
	DefaultInformationOriginateAlways types.Bool              `tfsdk:"default_information_originate_always"`
	DefaultMetric                     types.Int64             `tfsdk:"default_metric"`
	Distance                          types.Int64             `tfsdk:"distance"`
	DomainTag                         types.Int64             `tfsdk:"domain_tag"`
	MplsLdpAutoconfig                 types.Bool              `tfsdk:"mpls_ldp_autoconfig"`
	MplsLdpSync                       types.Bool              `tfsdk:"mpls_ldp_sync"`
	Neighbor                          []OSPFVRFNeighbor       `tfsdk:"neighbor"`
	Network                           []OSPFVRFNetwork        `tfsdk:"network"`
	Priority                          types.Int64             `tfsdk:"priority"`
	RouterId                          types.String            `tfsdk:"router_id"`
	Shutdown                          types.Bool              `tfsdk:"shutdown"`
	SummaryAddress                    []OSPFVRFSummaryAddress `tfsdk:"summary_address"`
}
type OSPFVRFNeighbor struct {
	Ip       types.String `tfsdk:"ip"`
	Priority types.Int64  `tfsdk:"priority"`
	Cost     types.Int64  `tfsdk:"cost"`
}
type OSPFVRFNetwork struct {
	Ip       types.String `tfsdk:"ip"`
	Wildcard types.String `tfsdk:"wildcard"`
	Area     types.String `tfsdk:"area"`
}
type OSPFVRFSummaryAddress struct {
	Ip   types.String `tfsdk:"ip"`
	Mask types.String `tfsdk:"mask"`
}

func (data OSPFVRF) getPath() string {
	return fmt.Sprintf("Cisco-IOS-XE-native:native/router/Cisco-IOS-XE-ospf:router-ospf/ospf/process-id-vrf=%v,%s", data.ProcessId.Value, data.Vrf.Value)
}

func (data OSPFVRF) toBody() string {
	body := `{"` + helpers.LastElement(data.getPath()) + `":{}}`
	if !data.ProcessId.Null && !data.ProcessId.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"id", strconv.FormatInt(data.ProcessId.Value, 10))
	}
	if !data.Vrf.Null && !data.Vrf.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"vrf", data.Vrf.Value)
	}
	if !data.BfdAllInterfaces.Null && !data.BfdAllInterfaces.Unknown {
		if data.BfdAllInterfaces.Value {
			body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"bfd.all-interfaces", map[string]string{})
		}
	}
	if !data.DefaultInformationOriginate.Null && !data.DefaultInformationOriginate.Unknown {
		if data.DefaultInformationOriginate.Value {
			body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"default-information.originate", map[string]string{})
		}
	}
	if !data.DefaultInformationOriginateAlways.Null && !data.DefaultInformationOriginateAlways.Unknown {
		if data.DefaultInformationOriginateAlways.Value {
			body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"default-information.originate.always", map[string]string{})
		}
	}
	if !data.DefaultMetric.Null && !data.DefaultMetric.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"default-metric", strconv.FormatInt(data.DefaultMetric.Value, 10))
	}
	if !data.Distance.Null && !data.Distance.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"distance.distance", strconv.FormatInt(data.Distance.Value, 10))
	}
	if !data.DomainTag.Null && !data.DomainTag.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"domain-tag", strconv.FormatInt(data.DomainTag.Value, 10))
	}
	if !data.MplsLdpAutoconfig.Null && !data.MplsLdpAutoconfig.Unknown {
		if data.MplsLdpAutoconfig.Value {
			body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"mpls.ldp.autoconfig", map[string]string{})
		}
	}
	if !data.MplsLdpSync.Null && !data.MplsLdpSync.Unknown {
		if data.MplsLdpSync.Value {
			body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"mpls.ldp.sync", map[string]string{})
		}
	}
	if !data.Priority.Null && !data.Priority.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"priority", strconv.FormatInt(data.Priority.Value, 10))
	}
	if !data.RouterId.Null && !data.RouterId.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"router-id", data.RouterId.Value)
	}
	if !data.Shutdown.Null && !data.Shutdown.Unknown {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"shutdown", data.Shutdown.Value)
	}
	if len(data.Neighbor) > 0 {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"neighbor", []interface{}{})
		for index, item := range data.Neighbor {
			if !item.Ip.Null && !item.Ip.Unknown {
				body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"neighbor"+"."+strconv.Itoa(index)+"."+"ip", item.Ip.Value)
			}
			if !item.Priority.Null && !item.Priority.Unknown {
				body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"neighbor"+"."+strconv.Itoa(index)+"."+"priority", strconv.FormatInt(item.Priority.Value, 10))
			}
			if !item.Cost.Null && !item.Cost.Unknown {
				body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"neighbor"+"."+strconv.Itoa(index)+"."+"cost", strconv.FormatInt(item.Cost.Value, 10))
			}
		}
	}
	if len(data.Network) > 0 {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"network", []interface{}{})
		for index, item := range data.Network {
			if !item.Ip.Null && !item.Ip.Unknown {
				body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"network"+"."+strconv.Itoa(index)+"."+"ip", item.Ip.Value)
			}
			if !item.Wildcard.Null && !item.Wildcard.Unknown {
				body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"network"+"."+strconv.Itoa(index)+"."+"wildcard", item.Wildcard.Value)
			}
			if !item.Area.Null && !item.Area.Unknown {
				body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"network"+"."+strconv.Itoa(index)+"."+"area", item.Area.Value)
			}
		}
	}
	if len(data.SummaryAddress) > 0 {
		body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"summary-address", []interface{}{})
		for index, item := range data.SummaryAddress {
			if !item.Ip.Null && !item.Ip.Unknown {
				body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"summary-address"+"."+strconv.Itoa(index)+"."+"ip", item.Ip.Value)
			}
			if !item.Mask.Null && !item.Mask.Unknown {
				body, _ = sjson.Set(body, helpers.LastElement(data.getPath())+"."+"summary-address"+"."+strconv.Itoa(index)+"."+"mask", item.Mask.Value)
			}
		}
	}
	return body
}

func (data *OSPFVRF) fromBody(res gjson.Result) {
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "bfd.all-interfaces"); value.Exists() {
		data.BfdAllInterfaces.Value = true
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "default-information.originate"); value.Exists() {
		data.DefaultInformationOriginate.Value = true
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "default-information.originate.always"); value.Exists() {
		data.DefaultInformationOriginateAlways.Value = true
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "default-metric"); value.Exists() {
		data.DefaultMetric.Value = value.Int()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "distance.distance"); value.Exists() {
		data.Distance.Value = value.Int()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "domain-tag"); value.Exists() {
		data.DomainTag.Value = value.Int()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "mpls.ldp.autoconfig"); value.Exists() {
		data.MplsLdpAutoconfig.Value = true
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "mpls.ldp.sync"); value.Exists() {
		data.MplsLdpSync.Value = true
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "neighbor"); value.Exists() {
		data.Neighbor = make([]OSPFVRFNeighbor, 0)
		value.ForEach(func(k, v gjson.Result) bool {
			item := OSPFVRFNeighbor{}
			if cValue := v.Get("ip"); cValue.Exists() {
				item.Ip.Value = cValue.String()
			}
			if cValue := v.Get("priority"); cValue.Exists() {
				item.Priority.Value = cValue.Int()
			}
			if cValue := v.Get("cost"); cValue.Exists() {
				item.Cost.Value = cValue.Int()
			}
			data.Neighbor = append(data.Neighbor, item)
			return true
		})
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "network"); value.Exists() {
		data.Network = make([]OSPFVRFNetwork, 0)
		value.ForEach(func(k, v gjson.Result) bool {
			item := OSPFVRFNetwork{}
			if cValue := v.Get("ip"); cValue.Exists() {
				item.Ip.Value = cValue.String()
			}
			if cValue := v.Get("wildcard"); cValue.Exists() {
				item.Wildcard.Value = cValue.String()
			}
			if cValue := v.Get("area"); cValue.Exists() {
				item.Area.Value = cValue.String()
			}
			data.Network = append(data.Network, item)
			return true
		})
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "priority"); value.Exists() {
		data.Priority.Value = value.Int()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "router-id"); value.Exists() {
		data.RouterId.Value = value.String()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "shutdown"); value.Exists() {
		data.Shutdown.Value = value.Bool()
	}
	if value := res.Get(helpers.LastElement(data.getPath()) + "." + "summary-address"); value.Exists() {
		data.SummaryAddress = make([]OSPFVRFSummaryAddress, 0)
		value.ForEach(func(k, v gjson.Result) bool {
			item := OSPFVRFSummaryAddress{}
			if cValue := v.Get("ip"); cValue.Exists() {
				item.Ip.Value = cValue.String()
			}
			if cValue := v.Get("mask"); cValue.Exists() {
				item.Mask.Value = cValue.String()
			}
			data.SummaryAddress = append(data.SummaryAddress, item)
			return true
		})
	}
}

func (data *OSPFVRF) fromPlan(plan OSPFVRF) {
	data.Device = plan.Device
	data.ProcessId.Value = plan.ProcessId.Value
	data.Vrf.Value = plan.Vrf.Value
}
