//go:build testAll

// Code generated by "gen/generator.go"; DO NOT EDIT.

package provider

import (
	"testing"

	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/resource"
)

func TestAccIosxeEVPNInstance(t *testing.T) {
	resource.Test(t, resource.TestCase{
		PreCheck:                 func() { testAccPreCheck(t) },
		ProtoV6ProviderFactories: testAccProtoV6ProviderFactories,
		Steps: []resource.TestStep{
			{
				Config: testAccIosxeEVPNInstanceConfig_all(),
				Check: resource.ComposeTestCheckFunc(
					resource.TestCheckResourceAttr("iosxe_evpn_instance.test", "evpn_instance_num", "10"),
					resource.TestCheckResourceAttr("iosxe_evpn_instance.test", "vlan_based_replication_type_ingress", "false"),
					resource.TestCheckResourceAttr("iosxe_evpn_instance.test", "vlan_based_replication_type_static", "true"),
					resource.TestCheckResourceAttr("iosxe_evpn_instance.test", "vlan_based_replication_type_p2mp", "false"),
					resource.TestCheckResourceAttr("iosxe_evpn_instance.test", "vlan_based_replication_type_mp2mp", "false"),
					resource.TestCheckResourceAttr("iosxe_evpn_instance.test", "vlan_based_encapsulation", "vxlan"),
					resource.TestCheckResourceAttr("iosxe_evpn_instance.test", "vlan_based_auto_route_target", "false"),
					resource.TestCheckResourceAttr("iosxe_evpn_instance.test", "vlan_based_rd", "10:10"),
					resource.TestCheckResourceAttr("iosxe_evpn_instance.test", "vlan_based_route_target", "10:10"),
					resource.TestCheckResourceAttr("iosxe_evpn_instance.test", "vlan_based_route_target_both", "10:10"),
					resource.TestCheckResourceAttr("iosxe_evpn_instance.test", "vlan_based_route_target_import", "10:10"),
					resource.TestCheckResourceAttr("iosxe_evpn_instance.test", "vlan_based_route_target_export", "10:10"),
					resource.TestCheckResourceAttr("iosxe_evpn_instance.test", "vlan_based_ip_local_learning_disable", "false"),
					resource.TestCheckResourceAttr("iosxe_evpn_instance.test", "vlan_based_ip_local_learning_enable", "true"),
					resource.TestCheckResourceAttr("iosxe_evpn_instance.test", "vlan_based_default_gateway_advertise", "enable"),
					resource.TestCheckResourceAttr("iosxe_evpn_instance.test", "vlan_based_re_originate_route_type5", "true"),
				),
			},
			{
				ResourceName:  "iosxe_evpn_instance.test",
				ImportState:   true,
				ImportStateId: "Cisco-IOS-XE-native:native/l2vpn/Cisco-IOS-XE-l2vpn:evpn_cont/evpn-instance/evpn/instance/instance=10",
			},
		},
	})
}

func testAccIosxeEVPNInstanceConfig_minimum() string {
	return `
	resource "iosxe_evpn_instance" "test" {
		evpn_instance_num = 10
	}
	`
}

func testAccIosxeEVPNInstanceConfig_all() string {
	return `
	resource "iosxe_evpn_instance" "test" {
		evpn_instance_num = 10
		vlan_based_replication_type_ingress = false
		vlan_based_replication_type_static = true
		vlan_based_replication_type_p2mp = false
		vlan_based_replication_type_mp2mp = false
		vlan_based_encapsulation = "vxlan"
		vlan_based_auto_route_target = false
		vlan_based_rd = "10:10"
		vlan_based_route_target = "10:10"
		vlan_based_route_target_both = "10:10"
		vlan_based_route_target_import = "10:10"
		vlan_based_route_target_export = "10:10"
		vlan_based_ip_local_learning_disable = false
		vlan_based_ip_local_learning_enable = true
		vlan_based_default_gateway_advertise = "enable"
		vlan_based_re_originate_route_type5 = true
	}
	`
}
